#pragma once
#include <sys/stat.h>
#include <libgen.h>
#include <cmath>
#include <limits>
#include <fstream>
#include <string>
#include <sstream>
#include <bitset>
#include "ndm.hh"


namespace NDM {
namespace Utils {

inline bool is_equal(double a, double b, double error_factor = 1.0)
{
    return a == b ||
           std::abs(a - b) < std::abs(std::fmin(a, b)) * std::numeric_limits<double>::epsilon() * error_factor;
}

inline void asci_to_protobuf(std::string a, std::string & p)
{
    std::stringstream sstream(a);
    p.clear();
    while (sstream.good()) {
        std::bitset<8> bits;
        sstream >> bits;
        char c = char(bits.to_ulong());
        p += c;
    }
}

inline void protobuf_to_asci(std::string p, std::string & a)
{
    for (std::size_t i = 0; i < p.size(); ++i) {
        std::bitset<8> xx = std::bitset<8>(p[i]);
        a += xx.to_string();
    }
}
inline int mkpath(const char * dir, mode_t mode)
{
    struct stat st;
    if (!dir) {
        errno = EINVAL;
        return 1;
    }
    if (!stat(dir, &st)) return 0;
    mkpath(dirname(strdupa(dir)), mode);
    return mkdir(dir, mode);
}

} // namespace Utils
} // namespace NDM
